import { ClassRef } from 'treat';
import type { StyleInjector } from './StyleInjector';
export interface RuleManager {
    increaseUsage(className: ClassRef, cssText: () => string): void;
    decreaseUsage(className: ClassRef, byAmount: number): void;
}
export declare class NullRuleManager implements RuleManager {
    increaseUsage(): void;
    decreaseUsage(): void;
}
export declare class OptimizedRuleManager implements RuleManager {
    private injector;
    private ruleIndexesByClassName;
    private usageCountsByClassName;
    constructor(injector: StyleInjector, initialRuleIndexesByClassName: Map<ClassRef, number>);
    increaseUsage(className: ClassRef, cssText: () => string): void;
    decreaseUsage(className: ClassRef, byAmount: number): void;
}
//# sourceMappingURL=RuleManager.d.ts.map