import { CSSProperties } from 'react';
import { ThemeOrAny } from 'treat/theme';
import { LiteralUnion, ValueOf } from 'type-fest';
import { Tokens } from './theme';
declare type ResolveShorthand<T extends Tokens<'shorthands'>> = ValueOf<ThemeOrAny['shorthands'][T], number>;
declare type ResolveAlias<T extends Tokens<'aliases'>> = ThemeOrAny['aliases'][T] extends Tokens<'shorthands'> ? ResolveShorthand<ThemeOrAny['aliases'][T]> : ThemeOrAny['aliases'][T];
declare type ScaleKeys<Property> = LiteralUnion<Extract<keyof ThemeOrAny['scales'][ThemeOrAny['matchers'][Extract<Property, Tokens<'matchers'>>]], ValueOf<CSSProperties>>, ValueOf<CSSProperties>>;
export declare type ThemedStyle = CSSProperties & {
    [key in Tokens<'matchers'>]?: ScaleKeys<key>;
} & {
    [key in Tokens<'shorthands'>]?: ScaleKeys<ResolveShorthand<key>>;
} & {
    [key in Tokens<'aliases'>]?: ScaleKeys<ResolveAlias<key>>;
};
export declare function useStyling(): (themedStyle: ThemedStyle) => string;
export {};
//# sourceMappingURL=useStyling.d.ts.map