import * as React from 'react';
import { isDev } from './env';
import { DebuggableStyleInjector, NullStyleInjector, OptimizedStyleInjector, } from './StyleInjector';
export const StyleInjectorContext = React.createContext(new NullStyleInjector());
export function StyleInjectorProvider({ children, injector = isDev
    ? new DebuggableStyleInjector()
    : new OptimizedStyleInjector(), }) {
    return (React.createElement(StyleInjectorContext.Provider, { value: injector }, children));
}
//# sourceMappingURL=StyleInjectorContext.js.map