const defaultSteps = [-1, -0.5, 0, +1, +2, +3, +4, +5, +6];
export function modularScale(ratio, steps = defaultSteps) {
    const tokens = {};
    steps.forEach((step) => {
        // Rounding to 3 decimal places
        tokens[step] = `${Math.round(ratio ** step * 1e3) / 1e3}rem`;
    });
    return tokens;
}
export function symmetricScale(nonNegativeTokens) {
    return Object.entries(nonNegativeTokens).reduce((tokens, [key, value]) => {
        // eslint-disable-next-line no-param-reassign
        if (key !== '0')
            tokens[`-${key}`] = `-${value}`;
        return tokens;
    }, { ...nonNegativeTokens });
}
//# sourceMappingURL=scales.js.map